<template src="./template.html" />
<style src="./style.scss" scoped lang="scss" />

<script>
    import axios from "axios";
    import {store} from "../../../../store/store";

    export default {
        name: "AccountList",
        data () {
            return {
                data: [],
                newAccount: {
                    idType: null,
                    nameType: '',
                    email: null,
                    password: null
                }

            }
        },
        components: {
        },
        computed: {

        },
        mounted() {
            this.getAccountwithTypes()
        },
        methods: {
            getAccountwithTypes() {
                axios({
                    method: "GET",
                    url: '/Account/admin/types',
                    headers: {
                        Authorization: 'Bearer ' + store.getters.token
                    },
                    data: {}
                }).then(response => {
                    this.data = response.data;
                }).catch(error => {
                    console.log(error)
                })
            },
            editAccount(id) {
                console.log(id);
            },
            deleteAccount(id) {
                this.$bvModal.msgBoxConfirm("Eliminare? L'azione è irreversibile")
                .then(value => {
                    if(value){
                        axios({
                            method: "DELETE",
                            url: "/Account/admin/" + id,
                            headers: {
                                Authorization: 'Bearer ' + store.getters.token
                            },
                            data: {}
                        })
                        .then(response => {
                            if(response.status === 200) {
                                console.log("Account eliminato con successo! ")
                                this.getAccountwithTypes();
                            }
                        })
                        .catch(error => {
                            this.$bvModal.msgBoxOk(error);
                        });
                    }
                });
            },
            recoverAccountPassword(id) {
                console.log(id);
            },  // TODO
            showCreateAccountModal(accountType, nameAccountType) {
                this.newAccount.idType = accountType;
                this.newAccount.nameType = nameAccountType;
                this.$bvModal.show('creationModal')
            },
            createAccount() {
                this.$bvModal.hide('creationModal');
                axios({
                    method: "POST",
                    "url": "account/admin/register/accountType/" + this.newAccount.idType,
                    headers: {
                        Authorization: 'Bearer ' + store.getters.token
                    },
                    data: {
                        "email": this.newAccount.email,
                        "password": this.newAccount.password
                    }
                }).then(() => {
                    this.$bvModal.msgBoxOk('L\'account è stato creato correttamente.', {
                        title: 'Ottimo!',
                        okVariant: 'success',
                        headerClass: 'p-2 border-bottom-0',
                        footerClass: 'p-2 border-top-0',
                        centered: true
                    });
                    this.getAccountwithTypes();
                }).catch((error) => {
                    console.log(error);
                    console.log(error.response);
                    this.error = error.response.data.error;
                    this.$bvModal.show('error-modal');
                });
            }
        }
    }
</script>
